from django.shortcuts import render
from rest_auth.registration.views import RegisterView
from .models import User, Genre, Author, Collection, Genders, Action, Metric, Book, UsersBooksCollections
from rest_framework import viewsets
from .serializers import GenreSerializer, AuthorSerializer, CollectionSerializer, GendersSerializer, ActionSerializer, MetricSerializer, BookSerializer, UsersBooksCollectionsSerializer, UserSerializer
#from .paginations import DefaultPagination
from rest_framework.permissions import IsAuthenticatedOrReadOnly 
from rest_framework.pagination import PageNumberPagination
#from .paginations import DefaultPagination

class DefaultPagination(PageNumberPagination):
    page_size = 3
    page_size_query_param = 'page_size'
    max_page_size = 12

class CustomRegisterView(RegisterView):
    queryset = User.objects.all()


class GenreViewSet(viewsets.ModelViewSet):
    queryset = Genre.objects.all()
    serializer_class = GenreSerializer
    permission_classes = [IsAuthenticatedOrReadOnly,]
    pagination_class = DefaultPagination

class AuthorViewSet(viewsets.ModelViewSet):
    queryset = Author.objects.all()
    serializer_class = AuthorSerializer
    permission_classes = [IsAuthenticatedOrReadOnly,]
    pagination_class = DefaultPagination


class CollectionViewSet(viewsets.ModelViewSet):
    queryset = Collection.objects.all()
    serializer_class = CollectionSerializer
    permission_classes = [IsAuthenticatedOrReadOnly,]
    pagination_class = DefaultPagination


class GendersViewSet(viewsets.ModelViewSet):
    queryset = Genders.objects.all()
    serializer_class = GendersSerializer
    permissions_classes = [IsAuthenticatedOrReadOnly,]
    pagination_class = DefaultPagination


class ActionViewSet(viewsets.ModelViewSet):
    queryset = Action.objects.all()
    serializer_class = ActionSerializer
    permissions_classes = [IsAuthenticatedOrReadOnly,]
    pagination_class = DefaultPagination


class MetricViewSet(viewsets.ModelViewSet):
    queryset = Metric.objects.all()
    serializer_class = MetricSerializer
    permissions_classes = [IsAuthenticatedOrReadOnly,]
    pagination_class = DefaultPagination

class BookViewSet(viewsets.ModelViewSet):
    queryset = Metric.objects.all()
    serializer_class = BookSerializer
    permissions_classes = [IsAuthenticatedOrReadOnly,]
    pagination_class = DefaultPagination


class UserViewSet(viewsets.ModelViewSet):
    queryset = User.objects.all()
    serializer_class = UserSerializer
    permissions_classes = [IsAuthenticatedOrReadOnly,]
    pagination_class = DefaultPagination 


class UsersBooksCollectionsViewSet(viewsets.ModelViewSet):
    queryset  = UsersBooksCollections.objects.all()
    serializer_class = UsersBooksCollectionsSerializer
    permissions_classes = [IsAuthenticatedOrReadOnly,]
    pagination_class = DefaultPagination

