package com.example.neurea.views.ui.theme

import android.app.Activity
import android.os.Build
import androidx.compose.foundation.isSystemInDarkTheme
import androidx.compose.material3.MaterialTheme
import androidx.compose.material3.MaterialTheme.shapes
import androidx.compose.material3.MaterialTheme.typography
import androidx.compose.material3.darkColorScheme
import androidx.compose.material3.dynamicDarkColorScheme
import androidx.compose.material3.dynamicLightColorScheme
import androidx.compose.material3.lightColorScheme
import androidx.compose.runtime.Composable
import androidx.compose.ui.platform.LocalContext

private val DarkColorScheme = darkColorScheme(
    primary = PrimaryGreenDark,
    secondary = SecondaryBlackDark,
    surface = SurfaceLightGreyDark,
    onPrimary = TextPrimaryDark,
    onSecondary = TextSecondaryDark
)

private val LightColorScheme = lightColorScheme(
    primary = PrimaryGreenLight,
    secondary = SecondaryWhiteLight,
    surface = SurfaceWhiteBlueLight,
    onPrimary = TextPrimaryLight,
    onSecondary = TextSecondaryLight
)

@Composable
fun NeureaTheme(
    darkTheme: Boolean = isSystemInDarkTheme(),
    content: @Composable () -> Unit
) {
    MaterialTheme(
        colorScheme = if(darkTheme) DarkColorScheme else LightColorScheme,
        shapes = shapes,
        typography = typography,
        content = content
    )
    }
